#include<reg52.h>
#include<intrins.h>
sbit SHCP=P1^0;
sbit STCP=P1^1;
sbit DS=P1^2;
sbit E1=P1^4;
sbit E2=P1^5;
sbit E3=P1^6;
sbit E4=P1^7;	
unsigned char i,j,n,k;
unsigned char code tab[]={0x00,0x20,0x20,0x60,0x20,0x20,0x20,0x10,0x20,0x10,0xFF,0x7F,0x00,0x00,0x00,0x00,//
                          0xFF,0x3F,0x20,0x40,0x10,0x40,0x08,0x40,0x0C,0x40,0x00,0x40,0x00,0x70,0x00,0x00,
                          0x00,0x00,0xFE,0xFF,0x02,0x40,0x0A,0x50,0x8A,0x50,0x8A,0x50,0x8A,0x50,0xFA,0x5F,//
                          0x8A,0x50,0xCA,0x52,0x8E,0x54,0x0A,0x50,0x02,0x40,0xFF,0xFF,0x02,0x00,0x00,0x00,
                          0x00,0x80,0x00,0x40,0xFE,0x3F,0x02,0x20,0x0A,0x10,0x12,0x08,0x62,0x06,0x82,0x01,//
                          0x62,0x06,0x1A,0x18,0x02,0x00,0xFF,0x3F,0x02,0x40,0x00,0x80,0x00,0xE0,0x00,0x00,
						  0x40,0x00,0x40,0x80,0x42,0x40,0x44,0x20,0x58,0x18,0xC0,0x07,0x40,0x00,0x7F,0x00,//
						  0x40,0x00,0xC0,0x3F,0x50,0x40,0x48,0x40,0x46,0x40,0x64,0x40,0x40,0x70,0x00,0x00,
                          };	
unsigned int code spec[] = {511,1023,2047,4095,8191,16383,32767,65535,1,3,7,15,31,63,127,255};


void delay(unsigned char time)
{
  unsigned char p;
  for(p=0;p<time;p++);
}
void write595(unsigned char dat)
{
  for(n=0;n<8;n++)
  {
    SHCP=0;
	DS=dat&0x80;
	dat<<=1;
	SHCP=1;
  }
}

void main(void)
{
  unsigned char sp;
  unsigned char tmp1;
  unsigned char tmp2;
  while(1)
  {
	for(sp = 7,k = 8;sp > 0;sp--,k++)
	{		  
		for(j=0;j<5;j++)
		{			  
			for(i=0;i<64;i++)
		 	 {
			  if((i < (sp<<2))||(i > (k<<2))) 
			  {
			  	tmp1 = 0x00;
			    tmp2 = 0x00;
			  }else{
			  	tmp1 = tab[2*i];
			  	tmp2 = tab[2*i+1];
			  }
			  
			  write595(~(tmp2));
			  write595(~(tmp1));

			  //write595(~((tab[2*i+1+m])&sp));
			  //write595(~((tab[2*i+m])&(sp>>8)));
			  STCP=0;
			  STCP=1;
			  if(i>=0 &&i<16){P2=i;   E1=0;}
			  if(i>=16&&i<32){P2=i-16;E2=0;}
			  if(i>=32&&i<48){P2=i-32;E3=0;}
			  if(i>=48&&i<64){P2=i-48;E4=0;}
			  delay(3);
			  E1=1;E2=1;E3=1;E4=1; 
			 }
		}
	 }
	 while(1)
		{			  
			for(i=0;i<64;i++)
		 	 {
			  tmp1 = tab[2*i];
			  tmp2 = tab[2*i+1];
			  write595(~(tmp2));
			  write595(~(tmp1));
 			  STCP=0;
			  STCP=1;
			  if(i>=0 &&i<16){P2=i;   E1=0;}
			  if(i>=16&&i<32){P2=i-16;E2=0;}
			  if(i>=32&&i<48){P2=i-32;E3=0;}
			  if(i>=48&&i<64){P2=i-48;E4=0;}
			  delay(2);
			  E1=1;E2=1;E3=1;E4=1; 
			 }
		}
	}
}

